// File: SocketClient.java
// TCP/IP Java Client Example

import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;
import java.net.*;

class SocketClient extends JFrame
		 implements ActionListener {

   JLabel text, clicked;
   JButton button,First,Second;
   JPanel panel;
   JTextField textField;
   Socket socket = null;
   PrintWriter out = null;
   BufferedReader in = null;

   SocketClient(){ //Begin Constructor
     text = new JLabel("Text to send over socket:");
     textField = new JTextField(20);
     button = new JButton("Click Me");
     button.addActionListener(this);
     First = new JButton("First");
     First.addActionListener(this);
     Second= new JButton("Second");
     Second.addActionListener(this);
     JPanel BPanel=new JPanel();
     BPanel.setLayout(new BorderLayout());
     BPanel.add("North",First);
     BPanel.add("South",Second);

     panel = new JPanel();
     panel.setLayout(new BorderLayout());
     panel.setBackground(Color.white);
     getContentPane().add(panel);
//     panel.add("North", text);
//     panel.add("Center", textField);
//     panel.add("South", button);
     panel.add("East",BPanel);
   } //End Constructor

  public void actionPerformed(ActionEvent event){
     Object source = event.getSource();
     // Can check for just a Button if only 1 Button
     if(source == button){
       //Send data over socket
          String text = textField.getText();
          out.println(text);
	  textField.setText(new String(""));
       //Receive text from server
       try{
	  String line = in.readLine();
          System.out.println("Text received :" + line);
       } catch (IOException e){
	 System.out.println("************* Read failed *************");
       	 System.exit(1);
       }
     }
     else if (source == First) 
	out.println("1");	
     else if (source == Second) 
	out.println("2");	
  }
  
  public void useSocket(String ServerName,int port)
  {  //Create socket connection
     try{
       socket = new Socket(ServerName, port);
       out = new PrintWriter(socket.getOutputStream(), true);
       in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
     } catch (UnknownHostException e) {
       System.out.println("Unknown host: acad");
       System.exit(1);
     } catch  (IOException e) {
       System.out.println("No I/O");
       System.exit(1);
     }
  }

   public static void main(String[] args)
   {    SocketClient frame = new SocketClient();
	frame.setTitle("Client Program");
        WindowListener l = new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                        System.exit(0);
                }
        };

        frame.addWindowListener(l);
        frame.pack();
        frame.setVisible(true);
	String ServerName="";
        int port=0;
	if (args.length==0) {
     	  try {
		ServerName=JOptionPane.showInputDialog("Input Server Name");
       		port=
		 Integer.parseInt(JOptionPane.showInputDialog("Input Port"));
     	  }
     	  catch (Exception noPort) {
       	    	System.out.println("Port not read");
       		System.exit(0);
     	  }
	}
	else try {
	  ServerName=args[0];
	  port=Integer.parseInt(args[1]);
	}
   	catch (Exception noPort) {
       	  System.out.println("Invalid Command Line Argument");
       	  System.exit(0);
     	}
	frame.useSocket(ServerName,port);
   }
}

